
//===========================================================================//
//                                                                           //
//  Copyright (C) 2004 - 2018                                                //
//  IDS Imaging GmbH                                                         //
//  Dimbacherstr. 6-8                                                        //
//  D-74182 Obersulm-Willsbach                                               //
//                                                                           //
//  The information in this document is subject to change without            //
//  notice and should not be construed as a commitment by IDS Imaging GmbH.  //
//  IDS Imaging GmbH does not assume any responsibility for any errors       //
//  that may appear in this document.                                        //
//                                                                           //
//  This document, or source code, is provided solely as an example          //
//  of how to utilize IDS software libraries in a sample application.        //
//  IDS Imaging GmbH does not assume any responsibility for the use or       //
//  reliability of any portion of this document or the described software.   //
//                                                                           //
//  General permission to copy or modify, but not for profit, is hereby      //
//  granted,  provided that the above copyright notice is included and       //
//  reference made to the fact that reproduction privileges were granted	 //
//	by IDS Imaging GmbH.				                                     //
//                                                                           //
//  IDS cannot assume any responsibility for the use or misuse of any        //
//  portion of this software for other than its intended diagnostic purpose	 //
//  in calibrating and testing IDS manufactured cameras and software.		 //
//                                                                           //
//===========================================================================//

// uEyeDigitalCropDlg.cpp : implementation file
//

#include "stdafx.h"
#include "uEyeDigitalCrop.h"
#include "uEyeDigitalCropDlg.h"
#include "afxdialogex.h"
#include <process.h>
#include <windows.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// required for running our image acquisition thread 
unsigned WINAPI threadProcImageQueue(void* pv);
CRITICAL_SECTION CriticalSection;


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();
	
// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CuEyeDigitalCropDlg dialog



CuEyeDigitalCropDlg::CuEyeDigitalCropDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_UEYEDIGITALCROP_DIALOG, pParent)
	, m_strCamType(_T(""))
	, m_strCamFps(_T(""))
	, m_strWidth(_T(""))
	, m_strHeight(_T(""))
	, m_strCropWidth(_T(""))
	, m_strCropHeight(_T(""))
	, m_strStepMin(_T(""))
	, m_strStepCurrent(_T(""))
	, m_strStepMax(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CuEyeDigitalCropDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_CAM_MODEL, m_strCamType);
	DDX_Text(pDX, IDC_EDIT_CAM_FPS, m_strCamFps);
	DDX_Control(pDX, IDC_BUTTON_LIVE, m_ctrlBtnLive);
	DDX_Text(pDX, IDC_EDIT_CAM_WIDTH, m_strWidth);
	DDX_Text(pDX, IDC_EDIT_CAM_HEIGHT, m_strHeight);
	DDX_Text(pDX, IDC_EDIT_CAM_CROP_WIDTH, m_strCropWidth);
	DDX_Text(pDX, IDC_EDIT_CAM_CROP_HEIGHT, m_strCropHeight);
	DDX_Text(pDX, IDC_EDIT_CROP_STEP_MIN, m_strStepMin);
	DDX_Text(pDX, IDC_EDIT_CROP_STEP_CURRENT, m_strStepCurrent);
	DDX_Text(pDX, IDC_EDIT_CROP_STEP_MAX, m_strStepMax);
	DDX_Control(pDX, IDC_SLIDER_FACTOR, m_ctrlSliderFactor);
	DDX_Control(pDX, IDC_RADIO_CROP_OFF, m_ctrlRadioBtnCropOff);
	DDX_Control(pDX, IDC_RADIO_CROP_SUBSAMPLING, m_ctrlRadioBtnCropSubSampling);
	DDX_Control(pDX, IDC_RADIO_CROP_BINNING, m_ctrlRadioBtnCropBinning);
	DDX_Control(pDX, IDC_RADIO_BINNING_AVERAGE, m_ctrlRadioBtnBinningAverage);
	DDX_Control(pDX, IDC_RADIO_BINNING_ADDITIVE, m_ctrlRadioBtnBinningAdditive);
	DDX_Control(pDX, IDC_RADIO_BINNING_ADDITIVE_AVERAGE, m_ctrlRadioBtnBinningAdditiveAverage);
	DDX_Control(pDX, IDC_RADIO_CROP_BAYER_BINNING, m_ctrlRadioBtnCropBayerScaling);
	DDX_Control(pDX, IDC_CHECK_DISPLAY_ORG, m_ctrlCheckBtnDisplayOrgImage);
	DDX_Control(pDX, IDC_CHECK_DISPLAY_CROP, m_ctrlCheckBtnDisplayCropImage);
	DDX_Control(pDX, IDC_BUTTON_INIT, m_ctrlBtnInit);
	DDX_Control(pDX, IDC_BUTTON_SNAP, m_ctrlBtnSnap);
}

BEGIN_MESSAGE_MAP(CuEyeDigitalCropDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_INIT, &CuEyeDigitalCropDlg::OnBnClickedButtonInit)
	ON_BN_CLICKED(IDC_BUTTON_EXIT, &CuEyeDigitalCropDlg::OnBnClickedButtonExit)
	ON_BN_CLICKED(IDC_BUTTON_SNAP, &CuEyeDigitalCropDlg::OnBnClickedButtonSnap)
	ON_BN_CLICKED(IDC_BUTTON_LIVE, &CuEyeDigitalCropDlg::OnBnClickedButtonLive)
	ON_BN_CLICKED(IDC_RADIO_CROP_OFF, &CuEyeDigitalCropDlg::OnBnClickedRadioCropOff)
	ON_BN_CLICKED(IDC_RADIO_CROP_BINNING, &CuEyeDigitalCropDlg::OnBnClickedRadioCropBinning)
	ON_BN_CLICKED(IDC_RADIO_CROP_SUBSAMPLING, &CuEyeDigitalCropDlg::OnBnClickedRadioCropSubsampling)
	ON_BN_CLICKED(IDC_RADIO_BINNING_AVERAGE, &CuEyeDigitalCropDlg::OnBnClickedRadioBinningAverage)
	ON_BN_CLICKED(IDC_RADIO_BINNING_ADDITIVE, &CuEyeDigitalCropDlg::OnBnClickedRadioBinningAdditive)
	ON_BN_CLICKED(IDC_RADIO_BINNING_ADDITIVE_AVERAGE, &CuEyeDigitalCropDlg::OnBnClickedRadioBinningAdditiveAverage)
	ON_BN_CLICKED(IDC_RADIO_CROP_BAYER_BINNING, &CuEyeDigitalCropDlg::OnBnClickedRadioCropBayerBinning)
	ON_BN_CLICKED(IDC_CHECK_DISPLAY_ORG, &CuEyeDigitalCropDlg::OnBnClickedCheckDisplayOrg)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_FACTOR, &CuEyeDigitalCropDlg::OnNMCustomdrawSliderFactor)
	ON_BN_CLICKED(IDC_CHECK_DISPLAY_CROP, &CuEyeDigitalCropDlg::OnBnClickedCheckDisplayCrop)
END_MESSAGE_MAP()


// CuEyeDigitalCropDlg message handlers

BOOL CuEyeDigitalCropDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	// init variables
	m_hCam = 0;								// no camera yet
	m_boRunThreadImageQueue = false;		// no image acquisition yet
	m_bLive = false;						// not live yet
	m_bColor = false;						// we do not know yet
	m_nCropMode = CROP_MODE_OFF;			// no crop yet
	m_nSubSamplingFactor = 1;				// not yet
	m_nBinningFactor = 1;					// not yet
	m_bDisplayOrgImage = true;				// display the original image
	m_bDisplayCropImage = true;				// display the cropped image
	m_nBinningMode= CROP_BINNING_AVERAGE;	// default mode
	m_pcCropImgMem = NULL;					// no crop memory buffer yet


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CuEyeDigitalCropDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}



// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CuEyeDigitalCropDlg::OnClose()
{
	if (CanExit()) {
		// stop image acquisition and related threads
		CamTerminateImageQueue();

		// memory and events are automatically released
		is_ExitCamera(m_hCam);

		// release resources used by the critical section object.
		DeleteCriticalSection(&CriticalSection);

		CDialogEx::OnClose();
	}

}

void CuEyeDigitalCropDlg::OnOK()
{
	if (CanExit())
		CDialogEx::OnOK();
}

void CuEyeDigitalCropDlg::OnCancel()
{
	if (CanExit())
		CDialogEx::OnCancel();
}

BOOL CuEyeDigitalCropDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CuEyeDigitalCropDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CuEyeDigitalCropDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		OpenCamera() 
//
// DESCRIPTION: Open a camera.
//				Setup display windows.
//				Setup color mode.
//				Setup memory management.
//				Setup threading.
//				Setup GUI.
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CamOpen()
{

	INT nRet = 0;

	if (m_hCam != 0)
		is_ExitCamera(m_hCam);

	// init camera
	m_hCam = (HIDS)0;  // open next camera
	nRet = InitCamera(&m_hCam, NULL);
	if (nRet == IS_SUCCESS)
	{

		// enable/disable the dialog based error report
		// when disable we are not interrupted in execustion with message boxes on upcoming SDK errors
		nRet = is_SetErrorReport(m_hCam, IS_DISABLE_ERR_REP); // or IS_ENABLE_ERR_REP);
		if (nRet != IS_SUCCESS)
		{
			AfxMessageBox(_T("ERROR: Can not disable the automatic uEye error report!"), MB_ICONEXCLAMATION, 0);
			return false;
		}


		// initialize the critical section one time only.
		if (!InitializeCriticalSectionAndSpinCount(&CriticalSection, 0x00000400))
		{
			AfxMessageBox(_T("ERROR: Can not inititalize the critical section"), MB_ICONEXCLAMATION, 0);
			return false;
		}


		// query camera information
		is_GetSensorInfo(m_hCam, &m_SensorInfo);
		CAMINFO CamInfo;
		is_GetCameraInfo(m_hCam, &CamInfo);


		// use color depth according to monochrome or color camera
		// allocate memory and build the sequence
		if (m_SensorInfo.nColorMode == IS_COLORMODE_MONOCHROME)
		{
			// monochrome camera
			m_bColor = false;
			CamSeqBuild(IS_CM_MONO8);
		}
		else
		{
			// color camera
			m_bColor = true;
			CamSeqBuild(IS_CM_BGRA8_PACKED);
		}

		
		// display initialization
		m_hWndDisplayOrg	= GetDlgItem(IDC_DISPLAY_ORG)->GetSafeHwnd();
		m_hWndDisplayCrop	= GetDlgItem(IDC_DISPLAY_CROP)->GetSafeHwnd();
		is_SetDisplayMode(m_hCam, IS_SET_DM_DIB);


		// trigger mode
		is_SetExternalTrigger(m_hCam, IS_SET_TRIGGER_OFF);	// we also could use IS_SET_TRIGGER_SOFTWARE


		// run the image queue and show live video
		CamRunImageQueue();
		CamToggleLive();


		// GUI
		m_strCamType = m_SensorInfo.strSensorName;
		m_strCamFps.Format(_T("%4.1f"), m_fps);
		m_strWidth.Format(_T("%d"), m_nSizeX);
		m_strHeight.Format(_T("%d"), m_nSizeY);
		m_strCropWidth.Format(_T("%d"), m_nSizeX);
		m_strCropHeight.Format(_T("%d"), m_nSizeY);
		m_ctrlSliderFactor.SetRange(CROP_MIN, CROP_MAX, true);
		m_ctrlSliderFactor.SetPos(CROP_MIN);
		m_ctrlSliderFactor.SetTicFreq(CROP_STEP);
		m_ctrlSliderFactor.SetTic(CROP_STEP),
		m_strStepMin.Format(_T("%d"), CROP_MIN);
		m_strStepMax.Format(_T("%d"), CROP_MAX);
		m_strStepCurrent.Format(_T("%d"), CROP_MIN);
		m_ctrlRadioBtnCropOff.SetCheck(BST_CHECKED);
		if (m_bColor) m_ctrlRadioBtnCropBayerScaling.EnableWindow(true);
		m_ctrlCheckBtnDisplayOrgImage.SetCheck(m_bDisplayOrgImage);
		m_ctrlCheckBtnDisplayCropImage.SetCheck(m_bDisplayCropImage);
		m_ctrlBtnInit.EnableWindow(false);
		m_ctrlBtnSnap.EnableWindow(true);
		m_ctrlBtnLive.EnableWindow(true);
		m_ctrlRadioBtnCropOff.EnableWindow(true);
		m_ctrlRadioBtnCropSubSampling.EnableWindow(true);
		m_ctrlRadioBtnCropBinning.EnableWindow(true);
		UpdateData(FALSE);
	}
	else
	{
		// there is no camera => we exit the application
		AfxMessageBox(_T("ERROR: Cannot open uEye camera!"), MB_ICONEXCLAMATION, 0);
		PostQuitMessage(0);
	}

	return true;
}




///////////////////////////////////////////////////////////////////////////////
//
// METHOD		InitCamera() 
//
// DESCRIPTION: This is the actual initialization of the camera
//				Perform firmware upload if required.
//
///////////////////////////////////////////////////////////////////////////////
INT CuEyeDigitalCropDlg::InitCamera(HIDS *hCam, HWND hWnd)
{
	INT nRet = is_InitCamera(hCam, hWnd);
	/************************************************************************************************/
	/*                                                                                              */
	/*  If the camera returns with "IS_STARTER_FW_UPLOAD_NEEDED", an upload of a new firmware       */
	/*  is necessary. This upload can take several seconds. We recommend to check the required      */
	/*  time with the function is_GetDuration().                                                    */
	/*                                                                                              */
	/*  In this case, the camera can only be opened if the flag "IS_ALLOW_STARTER_FW_UPLOAD"        */
	/*  is "OR"-ed to m_hCam. This flag allows an automatic upload of the firmware.                 */
	/*                                                                                              */
	/************************************************************************************************/
	if (nRet == IS_STARTER_FW_UPLOAD_NEEDED)
	{
		// Time for the firmware upload = 25 seconds by default
		INT nUploadTime = 25000;
		is_GetDuration(*hCam, IS_STARTER_FW_UPLOAD, &nUploadTime);

		CString Str1, Str2, Str3;
		Str1 = _T("This camera requires a new firmware. The upload will take about");
		Str2 = _T("seconds. Please wait ...");
		Str3.Format(_T("%s %d %s"), Str1, nUploadTime / 1000, Str2);
		AfxMessageBox(Str3, MB_ICONWARNING);

		// Set mouse to hourglass
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));

		// Try again to open the camera. This time we allow the automatic upload of the firmware by
		// specifying "IS_ALLOW_STARTER_FIRMWARE_UPLOAD"
		*hCam = (HIDS)(((INT)*hCam) | IS_ALLOW_STARTER_FW_UPLOAD);
		nRet = is_InitCamera(hCam, hWnd);
	}

	return nRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD:      CamSeqBuild()
//
// DESCRIPTION: Build a sequence for image acquisition using the sequence buffer
//				The number of buffers covers 1 second
//				At least 3 buffers are used
//				Use the image queue for save acquisition
//
// PARAMETERS:	ColorMode:	Color mode of the camera. We use appropriate image buffers
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CamSeqBuild(INT ColorMode)
{
	// variables
	bool bRet = false;	// this function return code
	INT nRet = 0;		// uEye return Code
	
	// apply color mode
	switch (ColorMode)
	{
		case IS_CM_MONO8:
		{
			m_nBitsPerPixel = 8;
			break;
		}
		case IS_CM_SENSOR_RAW8:
		{
			m_nBitsPerPixel = 8;
			break;
		}
		case IS_CM_BGR8_PACKED:
		{
			m_nBitsPerPixel = 24;
			break;
		}
		case IS_CM_BGRA8_PACKED:
		{
			m_nBitsPerPixel = 32;
			break;
		}
		default:
			return false;
	}
	m_nColorMode = ColorMode;
	is_SetColorMode(m_hCam, m_nColorMode);


	// how many buffers are required?
	// number of buffers according the frame rate
	// use at least 3 buffers
	double FrameTimeMin, FrameTimeMax, FrameTimeIntervall;
	nRet = is_GetFrameTimeRange(m_hCam, &FrameTimeMin, &FrameTimeMax, &FrameTimeIntervall);
	if (nRet == IS_SUCCESS)
	{
		double maxBuffers;
		m_fps = (1.0f / FrameTimeMin);
		maxBuffers = m_fps + 0.5f;
		m_nNumberOfBuffers = (int)(maxBuffers);

		if (m_nNumberOfBuffers < 3)
		{
			m_nNumberOfBuffers = 3;
		}

	}
	else
	{
		return false;
	}


	// calculate the image buffer width and height , watch if an (absolute) AOI is used
	IS_SIZE_2D imageSize;
	is_AOI(m_hCam, IS_AOI_IMAGE_GET_SIZE, (void*)&imageSize, sizeof(imageSize));
	INT nAllocSizeX = 0;
	INT nAllocSizeY = 0;
	m_nSizeX = nAllocSizeX = imageSize.s32Width;
	m_nSizeY = nAllocSizeY = imageSize.s32Height;
	UINT nAbsPosX = 0;
	UINT nAbsPosY = 0;
	is_AOI(m_hCam, IS_AOI_IMAGE_GET_POS_X_ABS, (void*)&nAbsPosX, sizeof(nAbsPosX));
	is_AOI(m_hCam, IS_AOI_IMAGE_GET_POS_Y_ABS, (void*)&nAbsPosY, sizeof(nAbsPosY));
	if (nAbsPosX)
	{
		nAllocSizeX = m_SensorInfo.nMaxWidth;
	}
	if (nAbsPosY)
	{
		nAllocSizeY = m_SensorInfo.nMaxHeight;
	}


	// allocate buffers (memory) in a loop
	int i;
	for (i = 0; i< m_nNumberOfBuffers; i++)
	{
		INT iImgMemID = 0;
		char* pcImgMem = 0;

		// allocate a single buffer memory
		nRet = is_AllocImageMem(m_hCam,
			nAllocSizeX,
			nAllocSizeY,
			m_nBitsPerPixel,
			&pcImgMem,
			&iImgMemID);
		if (nRet != IS_SUCCESS)
		{
			break;  // it makes no sense to continue
		}

		// put memory into the sequence buffer management
		nRet = is_AddToSequence(m_hCam, pcImgMem, iImgMemID);
		if (nRet != IS_SUCCESS)
		{
			// free latest buffer
			is_FreeImageMem(m_hCam, pcImgMem, iImgMemID);
			break;  // it makes no sense to continue
		}

		m_viSeqMemId.push_back(iImgMemID);
		m_vpcSeqImgMem.push_back(pcImgMem);

	}

	//store the line pitch
	is_GetImageMemPitch(m_hCam, &m_nPitch);
	m_dwPitch = m_nPitch / 4;

	// store current number buffers in case we did not match to get the desired number
	m_nNumberOfBuffers = i;

	// enable the image queue
	nRet = is_InitImageQueue(m_hCam, 0);
	if (nRet == IS_SUCCESS)
	{
		// we got buffers in the image queue
		if (m_nNumberOfBuffers >= 3)
			bRet = true;
	}


	return bRet;
}




///////////////////////////////////////////////////////////////////////////////
//
// METHOD:      CamSeqKill()
//
// DESCRIPTION: Release the sequence and memory of image buffers
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CamSeqKill()
{

	// exit image queue and release buffers from sequence
	is_ExitImageQueue(m_hCam);
	is_ClearSequence(m_hCam);


	// free buffers memory
	int i;
	for (i = (m_nNumberOfBuffers - 1); i >= 0; i--)
	{
		// free buffers
		if (is_FreeImageMem(m_hCam, m_vpcSeqImgMem.at(i), m_viSeqMemId.at(i)) != IS_SUCCESS)
		{
			return false;
		}
	}

	// no valid buffers any more
	m_viSeqMemId.clear();
	m_vpcSeqImgMem.clear();
	m_nNumberOfBuffers = 0;

	return true;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD:      CamRunImageQueue()
//
// DESCRIPTION: Install the image queue thread and run it
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CamRunImageQueue()
{
	// variables
	bool bRet = false;

	// create image queue thread
	m_boRunThreadImageQueue = TRUE;
	m_hThreadImageQueue = (HANDLE)_beginthreadex(NULL, 0, threadProcImageQueue, (void*)this, 0, (UINT*)&m_dwThreadIDImageQueue);
	if (m_hThreadImageQueue == NULL)
	{
		AfxMessageBox(_T("ERROR: Cannot create image queue thread!"), MB_ICONEXCLAMATION, 0);
		m_boRunThreadImageQueue = FALSE;
	}
	else
	{
		// capture thread must now be active
		bRet = true;
	}

	// we really shouldn't do that !!!!
	//SetThreadPriority (m_hThreadEvent, THREAD_PRIORITY_TIME_CRITICAL);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD:      CamTerminateImageQueue()
//
// DESCRIPTION: Stop the image acquisition
//				Terminate the image queue thread
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CamTerminateImageQueue()
{
	// variables
	bool bRet = false;


	// stop the image acquisition
	is_StopLiveVideo(m_hCam, IS_DONT_WAIT);

	
	// stop the thread loop 
	m_boRunThreadImageQueue = false;


	// finally terminate thread
	if (m_boTerminatedThreadImageQueue)
	{
		TerminateThread(m_hThreadImageQueue, 0);
		bRet = true;
	}
	CloseHandle(m_hThreadImageQueue);
	m_hThreadImageQueue = NULL;


	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD threadProc(void* pv)
//
// DESCRIPTION: Init thread for image queue handling
//
///////////////////////////////////////////////////////////////////////////////
unsigned WINAPI threadProcImageQueue(void* pv)
{
	CuEyeDigitalCropDlg* p = (CuEyeDigitalCropDlg*)pv;

	p->ThreadProcImageQueue();

	_endthreadex(0);

	return 0;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		ThreadProc()
//
// DESCRIPTION: Collect the images using the image queue
//				Run the required crop operation
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::ThreadProcImageQueue()
{
	// variables
	INT nMemID = 0;
	char *pBuffer = NULL;
	INT nRet;


	// run the the image queue acquisition
	do
	{
		m_boTerminatedThreadImageQueue = false;

		// collect the images
		nRet = is_WaitForNextImage(m_hCam, 1000, &pBuffer, &nMemID);
		if (nRet == IS_SUCCESS)
		{
			// display original image?
			if (m_bDisplayOrgImage)
			{
				is_RenderBitmap(m_hCam, nMemID, m_hWndDisplayOrg, IS_RENDER_FIT_TO_WINDOW);
			}

			
			// in case no crop effect is enabled (no crop memory) we display the original image instead
			if (m_pcCropImgMem)
			{

				// request ownership of the critical section.
				EnterCriticalSection(&CriticalSection);

				// run the crop effect
				switch (m_nCropMode)
				{

					case CROP_MODE_SUBSAMPLING:
					{
						CropDoSubSampling(m_nSubSamplingFactor, pBuffer);
						break;
					}

					case CROP_MODE_BINNING:
					{
						CropDoBinning(m_nBinningFactor, pBuffer);
						break;
					}

					case CROP_BAYER_SCALING:
					{
						CropDoBayerScaling(pBuffer);
						break;
					}


					default:
					{
						// cool, no need to do anything
						;
					}
				}
			
				// release ownership of the critical section.
				LeaveCriticalSection(&CriticalSection);

			} // end if m_pcCropImgMem
			else
			{
				// display the original image in the crop window
				if (m_bDisplayCropImage)
				{
					nRet = is_RenderBitmap(m_hCam, nMemID, m_hWndDisplayCrop, IS_RENDER_FIT_TO_WINDOW);
				}
			}
			
			is_UnlockSeqBuf(m_hCam, nMemID, pBuffer);	// finally unlock the source image buffer

		}


	} while (m_boRunThreadImageQueue);

	// that's it
	m_boTerminatedThreadImageQueue = true;

}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CamToggleLive
//
// DESCRIPTION: When live:		stop it
//				When not live:	start it
//				Serve GUI
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CamToggleLive()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code

	// toggle live video
	if (m_bLive == true)
	{
		nRet = is_StopLiveVideo(m_hCam, IS_DONT_WAIT);
		if (nRet == IS_SUCCESS)
		{
			m_bLive = false;
			m_ctrlBtnLive.SetWindowTextW(_T("Live Video"));
		}
		else
		{
			bRet = false;
		}
	}
	else
	{
		nRet = is_CaptureVideo(m_hCam, IS_DONT_WAIT);
		if (nRet == IS_SUCCESS)
		{
			m_bLive = true;
			m_ctrlBtnLive.SetWindowTextW(_T("Stop live"));
		}
		else
		{
			bRet = false;
		}
	}

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropPrepareSubSampling
//
// DESCRIPTION: Prepare sub sampling
//				Allocate an appropriate image buffer
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropPrepareSubSampling()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code

	
	// which factor?
	int nPos = m_ctrlSliderFactor.GetPos();
	m_nSubSamplingFactor = nPos;


	// request ownership of the critical section.
	EnterCriticalSection(&CriticalSection);


	// use color depth according to monochrome or color camera
	// allocate memory and build the sequence
	if (m_SensorInfo.nColorMode == IS_COLORMODE_MONOCHROME)
	{
		// monochrome camera
		if (m_nColorMode != IS_CM_MONO8)
		{
			if (m_bLive) is_StopLiveVideo(m_hCam, IS_WAIT);
			CamSeqKill();
			CamSeqBuild(IS_CM_MONO8);
			if (m_bLive) is_CaptureVideo(m_hCam, IS_DONT_WAIT);
		}
	}
	else
	{
		// color camera
		if (m_nColorMode != IS_CM_BGRA8_PACKED)
		{
			if (m_bLive) is_StopLiveVideo(m_hCam, IS_WAIT);
			CamSeqKill();
			CamSeqBuild(IS_CM_BGRA8_PACKED);
			if (m_bLive) is_CaptureVideo(m_hCam, IS_DONT_WAIT);
		}
	}


	// image size and color format for crop
	m_nCropColorMode = m_nColorMode;
	m_nCropBitsPerPixel = m_nBitsPerPixel;
	m_nCropSizeY = m_nSizeY / m_nSubSamplingFactor;
	// note that for display reasons the monochrome line size must be a multiple number of 4byte (DWORD)
	if (m_SensorInfo.nColorMode == IS_COLORMODE_MONOCHROME)
	{
		// only for mono cameras and odd number of pixels per line (the number of bytes per line must be a multiple of 4)
		m_nCropSizeX = ((((m_nSizeX / m_nSubSamplingFactor * m_nCropBitsPerPixel) + 31) & ~31) >> 3);
		m_nCropAdjustX = m_nSizeX / m_nSubSamplingFactor;
	}
	else
	{
		// color camera
		m_nCropSizeX = m_nSizeX / m_nSubSamplingFactor;
	}

	
	// allocate crop image buffer
	nRet = is_AllocImageMem(m_hCam,
							m_nCropSizeX,
							m_nCropSizeY,
							m_nCropBitsPerPixel,
							&m_pcCropImgMem,
							&m_nCropMemId);
	if (nRet != IS_SUCCESS)
	{
		return false;	// it makes no sense to continue
	}


	// we need to know the pitch of the cropped image memory
	// using a wrong pitch would result in odd images (diagonal image shift)
	// we could also use is_GetImageMemPitch, but then this memory would need to be set active and destorys the installed image queue
	m_nCropLinePitch = (m_nCropSizeX * ((m_nCropBitsPerPixel + 7) / 8));	
	m_dwCropLinePitch = m_nCropLinePitch / 4;


	// release ownership of the critical section.
	LeaveCriticalSection(&CriticalSection);


	//GUI
	m_strCropWidth.Format(_T("%d"), m_nCropSizeX);
	m_strCropHeight.Format(_T("%d"), m_nCropSizeY);
	UpdateData(FALSE);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropCleanupSubSampling
//
// DESCRIPTION: Cleanup sub sampling
//				Free the appropriate image buffer
//
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropCleanupSubSampling()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code

	// request ownership of the critical section.
	EnterCriticalSection(&CriticalSection);

	// free crop image buffer
	nRet = is_FreeImageMem(m_hCam, m_pcCropImgMem, m_nCropMemId);
	if (nRet != IS_SUCCESS)
	{
		bRet = false;	// this should never happen
	}

	// no more crop
	m_pcCropImgMem = NULL;
	m_nCropMemId = 0;
	m_nCropMode = CROP_MODE_OFF;
	m_nSubSamplingFactor = 1;

	// release ownership of the critical section.
	LeaveCriticalSection(&CriticalSection);

	//GUI
	m_strCropWidth.Format(_T("%d"), m_nSizeX);
	m_strCropHeight.Format(_T("%d"), m_nSizeY);
	UpdateData(FALSE);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropDoSubSampling
//
// DESCRIPTION: Perform the software sub sampling
//				Write result into the sub sampling buffer
//				Display the buffer
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio.
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropDoSubSampling(int nFactor, char* pcSourceImgMem)
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code


	// monochrome: we run all operations byte-wise (8bit)
	// color: we run all operations double-word-wise (32bit)
	switch (m_nCropColorMode)
	{
		case IS_CM_MONO8:
		{
			DoSubSamplingMono(nFactor, pcSourceImgMem);
			break;
		}
		
		case IS_CM_BGRA8_PACKED:
		{
			DoSubSamplingColor(nFactor, pcSourceImgMem);
			break;
		}

		default:
			// nop for the time being
			bRet = false;
	}

	// display the cropped image
	if (m_bDisplayCropImage)
	{
		nRet = is_RenderBitmap(m_hCam, m_nCropMemId, m_hWndDisplayCrop, IS_RENDER_FIT_TO_WINDOW);
	}

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoSubSamplingMono
//
// DESCRIPTION: Perform the software sub sampling.
//				Source code snippet for: MONO
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio.
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoSubSamplingMono(int nFactor, char* pcSourceImgMem)
{
	// copy the bytes from the source to the traget image buffer
	// monochrome: we run all operations byte-wise (8bit)

	// pixel pointer offset 
	uint32_t nPixelOffsetSource = 0;	// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;		// pixel offset in the crop buffer

	// lines 
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest<m_nCropSizeX; xSource += nFactor, xDest++)
		{
			if (xDest > m_nCropAdjustX) break;					// special case for mono and odd crop factor because of correct rendering, do not fill the right hand adjust pixels
			nPixelOffsetSource = xSource + (ySource*m_nPitch);	// calculate the pixel position inside the source buffer
			nPixelOffsetCrop = (xDest)+yDest*m_nCropLinePitch;	// more tricky for the destination buffer, the line pitch can be an odd number
			*(m_pcCropImgMem + nPixelOffsetCrop) = *(pcSourceImgMem + nPixelOffsetSource);	// byte wise copy
		}
	}
}



//////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoSubSamplingColor
//
// DESCRIPTION: Perform the software sub sampling.
//				Source code snippet for: COLOR
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio.
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoSubSamplingColor(int nFactor, char* pcSourceImgMem)
{
	// color! we run all operations double-word-wise (32bit), that's faster, we copy 4bytes=1 pixel in a single step
	// copy the DWORDS from the source to the traget image buffer
	
	// pixel pointer offset 
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer

	// we use double word (32bit) pointers instead of byte pointers
	DWORD32 *pdwCropImgMem = (reinterpret_cast<DWORD32*> (m_pcCropImgMem));
	DWORD32 *pdwSourceImgMem = (reinterpret_cast<DWORD32*> (pcSourceImgMem));

	// lines 
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)	
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest<m_nCropSizeX; xSource += nFactor, xDest++)
		{
			nPixelOffsetSource = xSource + (ySource*m_dwPitch);	// calculate the pixel position inside the source buffer
			nPixelOffsetCrop = (xDest)+yDest*m_dwCropLinePitch;	// more tricky for the destination buffer, the line pitch can be an odd number
			*(pdwCropImgMem + nPixelOffsetCrop) = *(pdwSourceImgMem + nPixelOffsetSource);	// DWORD wise copy
		}
	}
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropPrepareBinning
//
// DESCRIPTION: Prepare sub binning
//				Allocate an appropriate image buffer
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropPrepareBinning()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code


	// which factor?
	int nPos = m_ctrlSliderFactor.GetPos();
	m_nBinningFactor = nPos;

	// request ownership of the critical section.
	EnterCriticalSection(&CriticalSection);

	// use color depth according to monochrome or color camera
	// allocate memory and build the sequence
	if (m_SensorInfo.nColorMode == IS_COLORMODE_MONOCHROME)
	{
		// monochrome camera
		if (m_nColorMode != IS_CM_MONO8)
		{
			if (m_bLive) is_StopLiveVideo(m_hCam, IS_WAIT);
			CamSeqKill();
			CamSeqBuild(IS_CM_MONO8);
			if (m_bLive) is_CaptureVideo(m_hCam, IS_DONT_WAIT);
		}
	}
	else
	{
		// color camera
		if (m_nColorMode != IS_CM_BGRA8_PACKED)
		{
			if (m_bLive) is_StopLiveVideo(m_hCam, IS_WAIT);
			CamSeqKill();
			CamSeqBuild(IS_CM_BGRA8_PACKED);
			if (m_bLive) is_CaptureVideo(m_hCam, IS_DONT_WAIT);
		}
	}


	// image size and color format for crop
	m_nCropColorMode = m_nColorMode;
	m_nCropBitsPerPixel = m_nBitsPerPixel;
	m_nCropSizeY = m_nSizeY / m_nBinningFactor;
	// note that for display reasons the monochrome line size must be a multiple number of 4byte (DWORD)
	if (m_SensorInfo.nColorMode == IS_COLORMODE_MONOCHROME)
	{
		// only for mono cameras and odd number of pixels per line (the number of bytes per line must be a multiple of 4)
		m_nCropSizeX = ((((m_nSizeX / m_nBinningFactor * m_nCropBitsPerPixel) + 31) & ~31) >> 3);
		m_nCropAdjustX = m_nSizeX / m_nBinningFactor;
	}
	else
	{
		// color camera
		m_nCropSizeX = m_nSizeX / m_nBinningFactor;
	}


	// allocate crop image buffer
	nRet = is_AllocImageMem(m_hCam,
							m_nCropSizeX,
							m_nCropSizeY,
							m_nCropBitsPerPixel,
							&m_pcCropImgMem,
							&m_nCropMemId);
	if (nRet != IS_SUCCESS)
	{
		return false;	// it makes no sense to continue
	}


	// we need to know the pitch of the cropped image memory
	// using a wrong pitch would result in odd images (diagonal image shift)
	// we could also use is_GetImageMemPitch, but then this memory would need to be set active and destorys the installed image queue
	m_nCropLinePitch = (m_nCropSizeX * ((m_nCropBitsPerPixel + 7) / 8));
	m_dwCropLinePitch = m_nCropLinePitch / 4;

	
	// release ownership of the critical section.
	LeaveCriticalSection(&CriticalSection);

	//GUI
	m_strCropWidth.Format(_T("%d"), m_nCropSizeX);
	m_strCropHeight.Format(_T("%d"), m_nCropSizeY);
	UpdateData(FALSE);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropCleanupBinning
//
// DESCRIPTION: Cleanup binning
//				Free the appropriate image buffer
//
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropCleanupBinning()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code

	// request ownership of the critical section.
	EnterCriticalSection(&CriticalSection);


	// free crop image buffer
	nRet = is_FreeImageMem(m_hCam, m_pcCropImgMem, m_nCropMemId);
	if (nRet != IS_SUCCESS)
	{
		bRet = false;	// this should never happen
	}

	//no more crop
	m_pcCropImgMem = NULL;
	m_nCropMemId = 0;
	m_nCropMode = CROP_MODE_OFF;
	m_nBinningFactor = 1;

	// release ownership of the critical section.
	LeaveCriticalSection(&CriticalSection);

	//GUI
	m_strCropWidth.Format(_T("%d"), m_nSizeX);
	m_strCropHeight.Format(_T("%d"), m_nSizeY);
	UpdateData(FALSE);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropDoBinning
//
// DESCRIPTION: Perform the software binning
//				Write result into the binning buffer
//				Display the buffer
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropDoBinning(int nFactor, char* pcSourceImgMem)
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code


	// different color modes, different source pixel binning 
	switch (m_nCropColorMode)
	{
		case IS_CM_MONO8:
		{
			// monochrome images, we work byte wise

			// we can run different binning modes
			switch (m_nBinningMode)
			{

				case CROP_BINNING_AVERAGE:
				{
					DoBinningMonoAverage(nFactor, pcSourceImgMem);
					break;
				}
				
				case CROP_BINNING_ADDITIVE:
				{
					DoBinningMonoAdditive(nFactor, pcSourceImgMem);
					break;
				}

				case CROP_BINNING_H_ADDITIVE_V_AVERAGE:
				{
					DoBinningMonoAdditiveAverage(nFactor, pcSourceImgMem);
					break;
				}

				default:
					// nop for the time being
					bRet = false;
			}
			break;
		}

		case IS_CM_BGRA8_PACKED:
		{
			// the reprensentaion of a RGB image in memory is BGRA
			// https://en.ids-imaging.com/manuals/uEye_SDK/EN/uEye_Manual_4.81/sdk_allgemeines_farbformate.html

			// we can run different binning modes
			switch (m_nBinningMode)
			{

				case CROP_BINNING_AVERAGE:
				{
					DoBinningColorAverage(nFactor, pcSourceImgMem);
					break;
				}

				case CROP_BINNING_ADDITIVE:
				{
					DoBinningColorAdditive(nFactor, pcSourceImgMem);
					break;
				}

				case CROP_BINNING_H_ADDITIVE_V_AVERAGE:
				{
					DoBinningColorAdditiveAverage(nFactor, pcSourceImgMem);
					break;
				}

			}
			break;
		}

		default:
			// nop for the time being
			bRet = false;
	}

	// display the cropped image
	if (m_bDisplayCropImage)
	{
		nRet = is_RenderBitmap(m_hCam, m_nCropMemId, m_hWndDisplayCrop, IS_RENDER_FIT_TO_WINDOW);
	}

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoBinningMonoAverage
//
// DESCRIPTION: Perform the software binning
//				Write result into the binning buffer
//				Binning mode:				AVERAGE, bulit mean value, image brightness stays the same
//				Source code snippet for:	MONO
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoBinningMonoAverage(int nFactor, char* pcSourceImgMem)
{
	// monochrome images, we work byte wise

	// variables
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	unsigned int nBinningValue = 0;			// value of binned pixel 
	unsigned int nDivisor;					// used for averaging, number of pixels for building the average

	// calculate average (mean value) binning
	nDivisor = nFactor * nFactor;

	//lines
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest < m_nCropSizeX; xSource += nFactor, xDest++)
		{
			if (xDest > m_nCropAdjustX) break;	// special case for mono and odd crop factor because of correct rendering, do not fill the right hand adjust pixels

			// binning cluster
			nBinningValue = 0;
			for (int y1 = 0; y1 < nFactor; y1++)
			{
				for (int x1 = 0; x1 < nFactor; x1++)
				{
					nPixelOffsetSource = (xSource + x1) + ((ySource + y1)*m_nPitch);	// calculate the pixel position inside the source buffer
					nBinningValue = *(reinterpret_cast<unsigned char*>(pcSourceImgMem + nPixelOffsetSource)) + nBinningValue;	// summate  pixels
				}
			}
			nBinningValue = nBinningValue / nDivisor;								// build average of the summated pixels
			nPixelOffsetCrop = (xDest)+yDest*m_nCropLinePitch;						// more tricky for the destination buffer, the line pitch can be an odd number
			*(m_pcCropImgMem + nPixelOffsetCrop) = (unsigned char)nBinningValue;	// byte wise copy to traget buffer
		}
	}
}


///////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoBinningMonoAdditive
//
// DESCRIPTION: Perform the software binning
//				Write result into the binning buffer
//				Binning mode:				ADDITIVE, add all pixels values, image brightness increases by nFactor
//				Source code snippet for:	MONO
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoBinningMonoAdditive(int nFactor, char* pcSourceImgMem)
{
	// monochrome images, we work byte wise

	// variables
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	unsigned int nBinningValue = 0;			// value of binned pixel 

	//lines
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest < m_nCropSizeX; xSource += nFactor, xDest++)
		{
			if (xDest > m_nCropAdjustX) break;	// special case for mono and odd crop factor because of correct rendering, do not fill the right hand adjust pixels
			
			// binning cluster
			nBinningValue = 0;
			for (int y1 = 0; y1 < nFactor; y1++)
			{
				for (int x1 = 0; x1 < nFactor; x1++)
				{
					nPixelOffsetSource = (xSource + x1) + ((ySource + y1)*m_nPitch);	// calculate the pixel position inside the source buffer
					nBinningValue = *(reinterpret_cast<unsigned char*>(pcSourceImgMem + nPixelOffsetSource)) + nBinningValue;	// summate  pixels
					if (nBinningValue > 255)
					{
						// we are in 8bit saturation, we cannot go beyond the 8bit limit for numbers
						nBinningValue = 255;
						break;
					}
				}
				
				
				// we are in 8bit saturation, we cannot go beyond the 8bit limit for numbers
				// no need to add more pixels
				if (nBinningValue >= 255)
				{
					nBinningValue = 255;
					break;
				}
			}
			nPixelOffsetCrop = (xDest)+yDest*m_nCropLinePitch;						// more tricky for the destination buffer, the line pitch can be an odd number
			*(m_pcCropImgMem + nPixelOffsetCrop) = (unsigned char)nBinningValue;	// byte wise copy to traget buffer
		}
	}
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoBinningMonoAdditiveAverage
//
// DESCRIPTION: Perform the software binning
//				Write result into the binning buffer
//				Binning mode:				H:ADDITIVE V:AVERAGE, image brightness increases by nFactor
//				Source code snippet for:	MONO
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoBinningMonoAdditiveAverage(int nFactor, char* pcSourceImgMem)
{
	// monochrome images, we work byte wise

	// variables
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	unsigned int nBinningValue = 0;			// value of binned pixel 
	unsigned int nDivisor;					// used for averaging, number of pixels for building the average

	// calculate average (mean value) in vertical direction and summarize the pixels in horizontal direction
	nDivisor = nFactor;
	unsigned int nBinningValueH = 0;	// horizontal
	unsigned int nBinningValueV = 0;	// vertical

	//lines
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest < m_nCropSizeX; xSource += nFactor, xDest++)
		{
			if (xDest > m_nCropAdjustX) break;	// special case for mono and odd crop factor because of correct rendering, do not fill the right hand adjust pixels

			// binning cluster
			nBinningValue = 0;
			nBinningValueH = 0;
			nBinningValueV = 0;
			for (int y1 = 0; y1 < nFactor; y1++)
			{
				nBinningValueH = 0;
				for (int x1 = 0; x1 < nFactor; x1++)
				{
					nPixelOffsetSource = (xSource + x1) + ((ySource + y1)*m_nPitch);	// calculate the pixel position inside the source buffer
					nBinningValueH = *(reinterpret_cast<unsigned char*>(pcSourceImgMem + nPixelOffsetSource)) + nBinningValueH;	// summate  horizontal pixels
					if (nBinningValueH > 255)
					{
						// we are in 8bit saturation, we cannot go beyond the 8bit limit for numbers
						nBinningValueH = 255;
						break;
					}
				}
				
				nBinningValueV = nBinningValueV + nBinningValueH; // summate all horizontally binned pixels 

			}

			nBinningValue = nBinningValueV / nDivisor;								// build average of summated horizontal pixels
			nPixelOffsetCrop = (xDest)+yDest*m_nCropLinePitch;						// more tricky for the destination buffer, the line pitch can be an odd number
			*(m_pcCropImgMem + nPixelOffsetCrop) = (unsigned char)nBinningValue;	// byte wise copy to traget buffer
		}
	}
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoBinningColorAverage
//
// DESCRIPTION: Perform the software binning
//				Write result into the binning buffer
//				Binning mode:				AVERAGE, bulit mean value, image brightness stays the same
//				Source code snippet for:	COLOR
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoBinningColorAverage(int nFactor, char* pcSourceImgMem)
{
	// color images, we read the source image buffer and write the destination image buffers using double words
	// the binning operations are performed byte wise

	// we use double word (32bit) pointers instead of byte pointers for reading out the source buffer and writing into the destination buffer
	DWORD32 *pdwCropImgMem = (reinterpret_cast<DWORD32*> (m_pcCropImgMem));
	DWORD32 *pdwSourceImgMem = (reinterpret_cast<DWORD32*> (pcSourceImgMem));

	// variables
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	unsigned int nDivisor;					// used for averaging, number of pixels for building the average
	unsigned int  nBinningValue[4];			// temporarily sum value of binned BGRA pixel 
	unsigned char cBinningValue[4];			// result value of binned BGRA pixel 
	unsigned int nPixelPitchRGB;			// pitch in bytes to the next RGB pixel

	// calculate average (mean value) in vertical and in horizontal direction in respect of the color pixel format
	nDivisor = nFactor * nFactor;
	nPixelPitchRGB = 4;	// BGRA 4byte format


	// lines 
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest < m_nCropSizeX; xSource += nFactor, xDest++)
		{
			// binning cluster
			memset(nBinningValue, 0, 4 * sizeof(unsigned int));
			for (uint32_t y1 = 0; y1 < nFactor; y1++)
			{
				for (uint32_t x1 = 0; x1 < nFactor; x1++)
				{
					// there are different methods of reading and processing pixel data
					// note: tests using a intel core i5 system showed that the pointer processing method consumes more CPU power than using the logical operations
					bool bPointerProcessing = false;
					if (bPointerProcessing)
					{
						// using pointers
						unsigned char cValue = 0;

						// calculate the pixel position inside the source buffer and read the RGB value
						nPixelOffsetSource = ((xSource + x1)*nPixelPitchRGB + ((ySource + y1)*m_nPitch));
						for (uint32_t nByteOffset = 0; nByteOffset<nPixelPitchRGB; nByteOffset++)
						{
							// read out the RGB values byte wise and summate
							cValue = *(pcSourceImgMem + nPixelOffsetSource + nByteOffset);
							nBinningValue[nByteOffset] = nBinningValue[nByteOffset] + cValue;
						}
					}
					else
					{
						// using logical operations
						DWORD32 dwRGBValue = 0;

						// calculate the pixel position inside the source buffer and read the RGB value
						nPixelOffsetSource = (xSource + x1) + ((ySource + y1)*m_dwPitch);
						dwRGBValue = *(pdwSourceImgMem + nPixelOffsetSource);

						// process BGR pixels, summate
						// add all pixel values, summate masking the RGB calues by using byte logical operation
						nBinningValue[0] = nBinningValue[0] + (dwRGBValue & 0xff);			// blue
						nBinningValue[1] = nBinningValue[1] + (dwRGBValue >> 8 & 0xff);		// green
						nBinningValue[2] = nBinningValue[2] + (dwRGBValue >> 16 & 0xff);	// red
					}
				}
			}

			//  build average of the summated BGR pixels
			for (uint32_t nBGR = 0; nBGR<nPixelPitchRGB; nBGR++)
			{
				cBinningValue[nBGR] = (unsigned char)(nBinningValue[nBGR] / nDivisor);
			}

			// write binning pixel value into the destinaion buffer
			nPixelOffsetCrop = (xDest)+yDest*m_dwCropLinePitch;	// more tricky for the destination buffer, the line pitch can be an odd number
			*(pdwCropImgMem + nPixelOffsetCrop) = *(reinterpret_cast<DWORD32*>(&cBinningValue[0]));	// DWORD wise copy into the target buffer
		}
	}

}


///////////////////////////////////////////////////////////////////////////////
//
// METHOD		 DoBinningColorAdditive
//
// DESCRIPTION: Perform the software binning.
//				Write result into the binning buffer
//				Binning mode:				ADDITIVE, add all pixels values, image brightness increases by nFactor
//				Source code snippet for:	COLOR
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoBinningColorAdditive(int nFactor, char* pcSourceImgMem)
{
	// color images, we read the source image buffer and write the destination image buffers using double words
	// the binning operations are performed byte wise

	// we use double word (32bit) pointers instead of byte pointers for reading out the source buffer and writing into the destination buffer
	DWORD32 *pdwCropImgMem = (reinterpret_cast<DWORD32*> (m_pcCropImgMem));
	DWORD32 *pdwSourceImgMem = (reinterpret_cast<DWORD32*> (pcSourceImgMem));

	// variables
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	unsigned int  nBinningValue[4];			// temporarily sum value of binned BGRA pixel 
	unsigned char cBinningValue[4];			// result value of binned BGRA pixel 
	unsigned int nPixelPitchRGB=4;			// pitch in bytes to the next RGB pixel, BGRA 4byte format

		
	// lines 
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)	
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest < m_nCropSizeX; xSource += nFactor, xDest++)
		{
			// binning cluster
			memset(nBinningValue, 0, 4 * sizeof(unsigned int));
			for (uint32_t y1 = 0; y1 < nFactor; y1++)
			{
				for (uint32_t x1 = 0; x1 < nFactor; x1++)
				{
					// using logical operations
					DWORD32 dwRGBValue = 0;

					// calculate the pixel position inside the source buffer and read the RGB value
					nPixelOffsetSource = (xSource + x1) + ((ySource + y1)*m_dwPitch);
					dwRGBValue = *(pdwSourceImgMem + nPixelOffsetSource);

					// process BGR pixels
					// add all pixel values, summate masking the RGB calues by using byte logical operation
					nBinningValue[0] = nBinningValue[0] + (dwRGBValue & 0xff);			// blue
					nBinningValue[1] = nBinningValue[1] + (dwRGBValue >> 8 & 0xff);		// green
					nBinningValue[2] = nBinningValue[2] + (dwRGBValue >> 16 & 0xff);	// red
				}
			}

			//  build average of the summated BGR pixels
			for (uint32_t nBGR = 0; nBGR < nPixelPitchRGB; nBGR++)
			{
				// there is no way to go beyond white
				if (nBinningValue[nBGR] > 255)
				{
					cBinningValue[nBGR] = 255;
				}
				else
				{
					cBinningValue[nBGR] = (unsigned char)(nBinningValue[nBGR]);
				}
			}

			// write binning pixel value into the destinaion buffer
			nPixelOffsetCrop = (xDest)+yDest*m_dwCropLinePitch;	// more tricky for the destination buffer, the line pitch can be an odd number
			*(pdwCropImgMem + nPixelOffsetCrop) = *(reinterpret_cast<DWORD32*>(&cBinningValue[0]));	// DWORD wise copy into the target buffer
		}
	}
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		DoBinningColorAdditiveAverage
//
// DESCRIPTION: Perform the software binning
//				Write result into the binning buffer
//				Binning mode:				H:ADDITIVE V:AVERAGE, image brightness increases by nFactor
//				Source code snippet for:	COLOR
//
// PARAMETERS:	nFactor:		Scaling factor horizontal and vertical the same for keeping the aspect ratio
//				pcSourceImgMem:	Pointer to the source image buffer
//
///////////////////////////////////////////////////////////////////////////////
void CuEyeDigitalCropDlg::DoBinningColorAdditiveAverage(int nFactor, char* pcSourceImgMem)
{
	// color images, we read the source image buffer and write the destination image buffers using double words
	// the binning operations aare performed byte wise

	// we use double word (32bit) pointers instead of byte pointers for reading out the source buffer and writing into the destination buffer
	DWORD32 *pdwCropImgMem = (reinterpret_cast<DWORD32*> (m_pcCropImgMem));
	DWORD32 *pdwSourceImgMem = (reinterpret_cast<DWORD32*> (pcSourceImgMem));

	// variables
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	unsigned int nDivisor;					// used for averaging, number of pixels for building the average
	unsigned int  nBinningValue[4];			// temporarily sum value of binned BGRA pixel 
	unsigned int  nBinningValueH[4];		// temporarily sum value of binned BGRA horizontal pixel 
	unsigned int  nBinningValueV[4];		// temporarily sum value of binned BGRA vertical pixel
	unsigned char cBinningValue[4];			// result value of binned BGRA pixel 
	unsigned int nPixelPitchRGB;			// pitch in bytes to the next RGB pixel

	// calculate average (mean value) in vertical direction and summarize the pixels in horizontal direction
	nPixelPitchRGB = 4;	// BGRA 4byte format
	nDivisor = nFactor;

	// lines 
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY;ySource += nFactor, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xDest < m_nCropSizeX; xSource += nFactor, xDest++)
		{
			// binning cluster
			memset(nBinningValue, 0, 4 * sizeof(unsigned int));
			memset(nBinningValueH, 0, 4 * sizeof(unsigned int));
			memset(nBinningValueV, 0, 4 * sizeof(unsigned int));
			for (uint32_t y1 = 0; y1 < nFactor; y1++)
			{
				for (uint32_t x1 = 0; x1 < nFactor; x1++)
				{
					// using logical operations

					// calculate the pixel position inside the source buffer and read the RGB value
					nPixelOffsetSource = (xSource + x1) + ((ySource + y1)*m_dwPitch);
					DWORD32 dwRGBValue = 0;
					dwRGBValue = *(pdwSourceImgMem + nPixelOffsetSource);

					// process BGR pixels
					// add all pixel values, summate masking the RGB calues by using byte logical operation
					nBinningValueH[0] = nBinningValueH[0] + (dwRGBValue & 0xff);		// blue
					if (nBinningValueH[0] > 255) nBinningValueH[0] = 255;				// blue sturation
					nBinningValueH[1] = nBinningValueH[1] + (dwRGBValue >> 8 & 0xff);	// green
					if (nBinningValueH[1] > 255) nBinningValueH[1] = 255;				// green sturation
					nBinningValueH[2] = nBinningValueH[2] + (dwRGBValue >> 16 & 0xff);	// red
					if (nBinningValueH[2] > 255) nBinningValueH[2] = 255;				// green sturation

				}
				nBinningValueV[0] = nBinningValueV[0] + nBinningValueH[0];	// blue
				nBinningValueV[1] = nBinningValueV[1] + nBinningValueH[1];	// green
				nBinningValueV[2] = nBinningValueV[2] + nBinningValueH[2];	// red
			}

			//  build average of the summated BGR pixels
			for (uint32_t nBGR = 0; nBGR < nPixelPitchRGB; nBGR++)
			{
				nBinningValue[nBGR] = nBinningValueV[nBGR] / nDivisor;
				cBinningValue[nBGR] = (unsigned char)(nBinningValue[nBGR]);
			}

			// write binning pixel value into the destinaion buffer
			nPixelOffsetCrop = (xDest)+yDest*m_dwCropLinePitch;	// more tricky for the destination buffer, the line pitch can be an odd number
			*(pdwCropImgMem + nPixelOffsetCrop) = *(reinterpret_cast<DWORD32*>(&cBinningValue[0]));	// DWORD wise copy into the target buffer
		}
	}

}


///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropPrepareBayerScaling
//
// DESCRIPTION: Prepare Bayer scaling 2x2
//				Only works with color cameras
//				Allocate an appropriate image buffer
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropPrepareBayerScaling()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code


	// request ownership of the critical section.
	EnterCriticalSection(&CriticalSection);

	// use raw bayer for the color camera
	// allocate memory and build the sequence
	if (m_SensorInfo.nColorMode == IS_COLORMODE_MONOCHROME)
	{
		// monochrome camera
		return false;
	}
	else
	{
		// color camera
		if (m_bLive) is_StopLiveVideo(m_hCam, IS_WAIT);
		CamSeqKill();
		CamSeqBuild(IS_CM_SENSOR_RAW8 );
		m_nCropColorMode = IS_CM_BGR8_PACKED;
		m_nCropBitsPerPixel = 24;
		if (m_bLive) is_CaptureVideo(m_hCam, IS_DONT_WAIT);
	}


	// image size for crop
	m_nCropSizeX = m_nSizeX / 2;
	m_nCropSizeY = m_nSizeY / 2;


	// allocate crop image buffer, for this case the color format of the crop buffer is different to the image queue
	is_SetColorMode(m_hCam, m_nCropColorMode);
	nRet = is_AllocImageMem(m_hCam,
		m_nCropSizeX,
		m_nCropSizeY,
		m_nCropBitsPerPixel,
		&m_pcCropImgMem,
		&m_nCropMemId);
	if (nRet != IS_SUCCESS)
	{
		return false;	// it makes no sense to continue
	}
	is_SetColorMode(m_hCam, m_nColorMode);


	// we need to know the pitch of the croped image memory
	// using a wrong pitch would result in odd images (diagonal image shift)
	// we could also use is_GetImageMemPitch, but then this memory would need to be set active and destorys the installed image queue
	m_nCropLinePitch = (m_nCropSizeX * ((m_nCropBitsPerPixel + 7) / 8));
	m_dwCropLinePitch = m_nCropLinePitch / 4;

	// release ownership of the critical section.
	LeaveCriticalSection(&CriticalSection);

	//GUI
	m_strCropWidth.Format(_T("%d"), m_nCropSizeX);
	m_strCropHeight.Format(_T("%d"), m_nCropSizeY);
	UpdateData(FALSE);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropCleanupBayerScaling
//
// DESCRIPTION: Cleanup Bayer scaling 2x2
//				Free the appropriate image buffer
//
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropCleanupBayerScaling()
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code

	
	// request ownership of the critical section.
	EnterCriticalSection(&CriticalSection);


	// free crop image buffer
	nRet = is_FreeImageMem(m_hCam, m_pcCropImgMem, m_nCropMemId);
	if (nRet != IS_SUCCESS)
	{
		bRet = false;	// this should never happen
	}

	// step back to standard color image acquisition
	if (m_bLive) is_StopLiveVideo(m_hCam, IS_WAIT);
	CamSeqKill();
	CamSeqBuild(IS_CM_BGRA8_PACKED);
	if (m_bLive) is_CaptureVideo(m_hCam, IS_DONT_WAIT);

	//no more crop
	m_pcCropImgMem = NULL;
	m_nCropMemId = 0;
	m_nCropMode = CROP_MODE_OFF;

	// release ownership of the critical section.
	LeaveCriticalSection(&CriticalSection);

	//GUI
	m_strCropWidth.Format(_T("%d"), m_nSizeX);
	m_strCropHeight.Format(_T("%d"), m_nSizeY);
	UpdateData(FALSE);

	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
//
// METHOD		CropDoBayerScaling
//
// DESCRIPTION: Perform a quick and dirty Bayer conversion
//              Take red + blue out of the Bayer cluster and build the average of the two green pixels for the destination RGB
//				Write result into the sub sampling buffer
//				Display the buffer
//
///////////////////////////////////////////////////////////////////////////////
bool CuEyeDigitalCropDlg::CropDoBayerScaling(char* pcSourceImgMem)
{
	// variables
	bool bRet = true;	// this function return code
	INT nRet = 0;		// uEye return code


	// variables
	unsigned char cRed;		// red pixel value
	unsigned char cGreen;	// green pixel value
	unsigned int  nGreen;	// temporarily sum value of binned green pixel
	unsigned char cGreen1;  // upper right green pixel of the cluster
	unsigned char cGreen2;  // lower left green pixel of the cluster
	unsigned char cBlue;	// blue pixel value


	// copy the bytes from the source to the traget image buffer
	uint32_t nPixelOffsetSource = 0;		// pixel offset in the source buffer
	uint32_t nPixelOffsetCrop = 0;			// pixel offset in the crop buffer
	uint32_t nClusterStep = 2;				// the Bayer cluster has a size of 2x2
	uint32_t nPixelPitch = 3;				// we use a RGB 24bit format, 3 bytes


	// we use double word (32bit) pointers instead of byte pointers for writing into the destination buffer
	DWORD32 *pdwCropImgMem = (reinterpret_cast<DWORD32*> (m_pcCropImgMem));

	// lines 
	for (uint32_t ySource = 0, yDest = 0; yDest<m_nCropSizeY ; ySource += nClusterStep, yDest++)
	{
		// pixels
		for (uint32_t xSource = 0, xDest = 0; xSource < m_nSizeX-1; xSource += nClusterStep, xDest=xDest+nPixelPitch)
		{
			// Bayer conversion cluster
			// the Bayer cluster always starts with red for uEye cameras
			// rg
			// gb

			// calculate the pixel position inside the source buffer
			nPixelOffsetSource = (xSource) + ((ySource)*m_nPitch);
					
			// read out the colored Bayer pixel of the cluster
			cRed = *(pcSourceImgMem + nPixelOffsetSource);
			cGreen1 = *(pcSourceImgMem + nPixelOffsetSource + 1);
			cGreen2 = *(pcSourceImgMem + nPixelOffsetSource + m_nPitch);
			cBlue = *(pcSourceImgMem + nPixelOffsetSource + m_nPitch + 1 );

			// calculate green average
			nGreen = cGreen1 + cGreen2;
			cGreen = nGreen / 2;

			// write color pixel value into the destinaion buffer
			nPixelOffsetCrop = (xDest)+yDest*m_nCropLinePitch;	
			*(m_pcCropImgMem + nPixelOffsetCrop) = cBlue;
			*(m_pcCropImgMem + nPixelOffsetCrop+1) = cGreen;
			*(m_pcCropImgMem + nPixelOffsetCrop+2) = cRed;
		}
	}
	
	// display the cropped image
	if (m_bDisplayCropImage)
	{
		nRet = is_RenderBitmap(m_hCam, m_nCropMemId, m_hWndDisplayCrop, IS_RENDER_FIT_TO_WINDOW);
	}


	return bRet;
}



///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//
// GUI 
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void CuEyeDigitalCropDlg::OnBnClickedButtonInit()
{
	// open camera and run image queue acquisition
	CamOpen();
}

void CuEyeDigitalCropDlg::OnBnClickedButtonExit()
{
	// stop image acquisition and related threads
	CamTerminateImageQueue();

	// memory and events are automatically released
	is_ExitCamera(m_hCam);

	// release resources used by the critical section object.
	DeleteCriticalSection(&CriticalSection);

	// terminate
	PostQuitMessage(0);
}


void CuEyeDigitalCropDlg::OnBnClickedButtonSnap()
{
	// snap an image
	if (m_bLive == true)
	{
		CamToggleLive();
	}
	else
	{
		is_FreezeVideo(m_hCam, IS_DONT_WAIT);
	}
}


void CuEyeDigitalCropDlg::OnBnClickedButtonLive()
{
	// toggle live video
	CamToggleLive();
}


void CuEyeDigitalCropDlg::GuiCropClean(void)
{
	switch (m_nCropMode)
	{
		case CROP_MODE_OFF:
		{
			// cool, no need to do anything
			break;
		}
		case CROP_MODE_SUBSAMPLING:
		{
			CropCleanupSubSampling();
			break;
		}
		case CROP_MODE_BINNING:
		{
			CropCleanupBinning();
			m_ctrlRadioBtnBinningAverage.EnableWindow(false);
			m_ctrlRadioBtnBinningAdditive.EnableWindow(false);;
			m_ctrlRadioBtnBinningAdditiveAverage.EnableWindow(false);;
			break;
		}
		case CROP_BAYER_SCALING:
		{
			CropCleanupBayerScaling();
			break;
		}
		default:
		{
			//claenaup all
			CropCleanupSubSampling();
			CropCleanupBinning();
			CropCleanupBayerScaling();
		}
	}
	m_nCropMode = CROP_MODE_OFF;

}

void CuEyeDigitalCropDlg::OnBnClickedRadioCropOff()
{
	// cleanup crop mode
	GuiCropClean();
	m_ctrlSliderFactor.EnableWindow(false);
	m_ctrlRadioBtnCropOff.SetFocus();
}

void CuEyeDigitalCropDlg::OnBnClickedRadioCropSubsampling()
{
	// cleanup previous crop mode
	GuiCropClean();

	// now let's start with the new crop mode
	int nPos = m_ctrlSliderFactor.GetPos();
	m_nSubSamplingFactor = nPos;
	m_nCropMode = CROP_MODE_SUBSAMPLING;
	CropPrepareSubSampling();

	// GUI
	m_ctrlSliderFactor.EnableWindow(true);
	m_strStepCurrent.Format(_T("%d"), nPos);
	m_ctrlSliderFactor.SetFocus();
	UpdateData(false);
}



void CuEyeDigitalCropDlg::OnBnClickedRadioCropBinning()
{
	// cleanup previous crop mode
	GuiCropClean();

	// now let's start with the new crop mode
	int nPos = m_ctrlSliderFactor.GetPos();
	m_nBinningFactor = nPos;
	m_nCropMode = CROP_MODE_BINNING;
	CropPrepareBinning();

	// GUI
	if (m_nBinningMode == CROP_BINNING_AVERAGE) m_ctrlRadioBtnBinningAverage.SetCheck(BST_CHECKED);
	if (m_nBinningMode == CROP_BINNING_ADDITIVE) m_ctrlRadioBtnBinningAdditive.SetCheck(BST_CHECKED);
	if (m_nBinningMode == CROP_BINNING_H_ADDITIVE_V_AVERAGE) m_ctrlRadioBtnBinningAdditiveAverage.SetCheck(BST_CHECKED);
	m_ctrlRadioBtnBinningAverage.EnableWindow(true);
	m_ctrlRadioBtnBinningAdditive.EnableWindow(true);
	m_ctrlRadioBtnBinningAdditiveAverage.EnableWindow(true);
	m_ctrlSliderFactor.EnableWindow(true);
	m_strStepCurrent.Format(_T("%d"), nPos);
	m_ctrlSliderFactor.SetFocus();
	UpdateData(false);	
}


void CuEyeDigitalCropDlg::OnBnClickedRadioBinningAverage()
{
	m_nBinningMode = CROP_BINNING_AVERAGE;
	m_ctrlSliderFactor.SetFocus();
}


void CuEyeDigitalCropDlg::OnBnClickedRadioBinningAdditive()
{
	m_nBinningMode = CROP_BINNING_ADDITIVE;
	m_ctrlSliderFactor.SetFocus();
}


void CuEyeDigitalCropDlg::OnBnClickedRadioBinningAdditiveAverage()
{
	m_nBinningMode = CROP_BINNING_H_ADDITIVE_V_AVERAGE;
	m_ctrlSliderFactor.SetFocus();
}

void CuEyeDigitalCropDlg::OnBnClickedRadioCropBayerBinning()
{
	// cleanup previous crop mode
	GuiCropClean();

	// now let's start with the new crop mode
	int nPos = m_ctrlSliderFactor.GetPos();
	m_nCropMode = CROP_BAYER_SCALING;
	CropPrepareBayerScaling();

	// GUI
	UpdateData(false);
}



void CuEyeDigitalCropDlg::OnBnClickedCheckDisplayOrg()
{
	m_bDisplayOrgImage = m_ctrlCheckBtnDisplayOrgImage.GetCheck();
}

void CuEyeDigitalCropDlg::OnBnClickedCheckDisplayCrop()
{
	m_bDisplayCropImage = m_ctrlCheckBtnDisplayCropImage.GetCheck();
}



void CuEyeDigitalCropDlg::OnNMCustomdrawSliderFactor(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);

	int nPos = m_ctrlSliderFactor.GetPos();

	if (m_nCropMode == CROP_MODE_SUBSAMPLING)
	{
		// stop the crop mode until we have setup the new factor
		m_nCropMode = CROP_MODE_OFF;
		CropCleanupSubSampling();
		m_nSubSamplingFactor = nPos;
		CropPrepareSubSampling();
		m_nCropMode = CROP_MODE_SUBSAMPLING;
	}

	if (m_nCropMode == CROP_MODE_BINNING)
	{
		// stop the crop mode until we have setup the new factor
		m_nCropMode = CROP_MODE_OFF;
		CropCleanupBinning();
		m_nBinningFactor = nPos;
		CropPrepareBinning();
		m_nCropMode = CROP_MODE_BINNING;
	}

	// GUI
	m_strStepCurrent.Format(_T("%d"), nPos);
	UpdateData(false);


	*pResult = 0;
}


